/*
 *	ctdecode.c
 *		Copyright (C)2001, 2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "ctdecode.h"

/* NmgK[̕R[h\(VOoCg) */
static const char *tbl_charcode[] =
{
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"o", "", "r", "", "u", "", "x", "", "{", "", "K", "", "M", "", "O", "",
	"Q", "", "S", "", "U", "", "W", "", "Y", "", "[", "", "]", "", "_", "",
	"a", "", "d", "", "f", "", "h", "", "", "p", "", "s", "", "v", "", "",
	"", "|", "", "0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "X",  "E",  "G",
	"n", "", "q", "", "t", "", "w", "", "z", "", "J", "", "L", "", "N", "",
	"P", "", "R", "", "T", "", "V", "", "X", "", "Z", "", "\", "", "^", "",
	"`", "", "c", "", "e", "", "g", "", "E", "", "A", "", "C", "", "G", "",
	"I", "", "i", "", "j", "", "k", "", "l", "", "m", "", "}", "", "~", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "b", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "@", "[", "B", "c", "D", "!",  "F", "?",  "H", "/",  "w", "x",
	"B", "A",  "B",  "Y",  "L",  "R",  "H",  "M",  "P",  "A", "u", ":",  "`", "", "", " ",
};

/* NmgK[̕R[h\(bZ[WpE}`oCg1oCg) */
static const char *tbl_charcode_mb1[] =
{
	/* 00 */	"",
	/* 01 */	"",
	/* 02 */	"",
	/* 03 */	"",
	/* 04 */	"",
	/* 05 */	"\n",
	/* 06 */	"\n  ",
	/* 07 */	"\n",
	/* 08 */	"\n  ",
	/* 09 */	"\n\n",
	/* 0a */	"\n\n  ",
	/* 0b */	"\n\n",
	/* 0c */	"\n\n  ",
	/* 0d */	"",
	/* 0e */	"",
	/* 0f */	"",
	/* 10 */	"",
	/* 11 */	"",
	/* 12 */	"",
	/* 13 */	"Nm",
	/* 14 */	"}[",
	/* 15 */	"bJ",
	/* 16 */	"{",
	/* 17 */	"JG",
	/* 18 */	"GC",
	/* 19 */	"",
	/* 1a */	"N",
	/* 1b */	"(1ԖڃLN^)",
	/* 1c */	"(2ԖڃLN^)",
	/* 1d */	"(3ԖڃLN^)",
	/* 1e */	"}[",
	/* 1f */	"(ACe)",
	/* 20 */	"Vo[h",
	/* 21 */	"cc",
	/* 22 */	"",
	/* 23 */	"ccB",
	/* 24 */	"l",
	/* 25 */	"",
	/* 26 */	"Ȃ",
	/* 27 */	"́A",
	/* 28 */	"!!",
	/* 29 */	"HX",
	/* 2a */	"",
	/* 2b */	"ɓꂽ",
	/* 2c */	"bu",
	/* 2d */	"cc!",
	/* 2e */	"",
	/* 2f */	"",
	/* 30 */	"",
	/* 31 */	"OhI",
	/* 32 */	"",
	/* 33 */	"Ă",
	/* 34 */	"O",
	/* 35 */	"rlK[",
	/* 36 */	"Rmc",
	/* 37 */	"",
	/* 38 */	"Ă",
	/* 39 */	"",
	/* 3a */	"{bV",
	/* 3b */	"TCX",
	/* 3c */	"B",
	/* 3d */	"rlK[u",
	/* 3e */	"",
	/* 3f */	"!?",

	"o", "", "r", "", "u", "", "x", "", "{", "", "K", "", "M", "", "O", "",
	"Q", "", "S", "", "U", "", "W", "", "Y", "", "[", "", "]", "", "_", "",
	"a", "", "d", "", "f", "", "h", "", "", "p", "", "s", "", "v", "", "",
	"", "|", "", "0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "X",  "E",  "G",
	"n", "", "q", "", "t", "", "w", "", "z", "", "J", "", "L", "", "N", "",
	"P", "", "R", "", "T", "", "V", "", "X", "", "Z", "", "\", "", "^", "",
	"`", "", "c", "", "e", "", "g", "", "E", "", "A", "", "C", "", "G", "",
	"I", "", "i", "", "j", "", "k", "", "l", "", "m", "", "}", "", "~", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "b", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "@", "[", "B", "c", "D", "!",  "F", "?",  "H", "/",  "w", "x",
	"B", "A",  "B",  "Y",  "L",  "R",  "H",  "M",  "P",  "A", "u", ":",  "`", "", "", " ",
};

/* NmgK[̕R[h\(bZ[WpE}`oCg2oCg) */
static const char *tbl_charcode_mb2[] =
{
	/* 0x01 */
	"l", "l", "", "s", "", "", "", "", "b", "", "o", "O", "", "", "", "B",
	"m", "", "", "", "", "C", "", "", "", "", "", "", "", "", "N", "",
	"", "", "", "", "b", "", "", "E", "R", "v", "c", "q", "", "V", "", "H",
	"", "", "R", "", "", "{", "", "", "@", "", "n", "g", "", "", "", "",
	"R", "", "", "S", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "A", "", "", "_", "", "", "`", "j", "", "p", "A", "m", "",
	"", "", "", "", "", "", "", "", "", "", "", "O", "X", "x", "", "", 
	"", "", "E", "", "", "", "c", "s", "C", "", "", "", "", "a", "", "", 
	"", "", "", "", "Z", "", "", "", "J", "", "", "", "", "C", "", "T", 
	"v", "", "", "", "", "", "", "", "", "", "e", "", "", "", "", "", 
	"]", "L", "V", "", "", "", "", "", "R", "I", "", "", "L", "", "p", "", 
	"", "", "", "\", "", "k", "", "", "A", "h", "", "t", "n", "", "", "M", 
	"|", "", "", "D", "", "N", "j", "", "", "N", "x", "", "g", "D", "L", "", 
	"@", "", "", "Y", "", "", "", "U", "", "", "", "", "", "", "", "", 
	"", "I", "", "", "S", "p", "^", "", "q", "", "", "", "", "", "", "", 
	"c", "", "K", "E", "v", "E", "a", "", "", "", "", "", "", "V", "", "F",

	/* 0x02 */
	"", "", "~", "", "", "", "", "", "", "Z", "", "", "", "", "a", "",
	"F", "", "", "", "", "", "", "", "", "", "", "r", "", "", "^", "",
	"z", "i", "", "", "", "H", "", "", "c", "", "", "p", "", "", "", "",
	"", "", "", "`", "}", "", "", "", "", "", "", "", "", "", "", "N",
	"", "", "", "", "", "", "", "L", "", "", "", "", "t", "", "", "",
	"", "d", "k", "", "", "j", "]", "u", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "l", "", "", "", "\", "G", "", "{",
	"", "[", "", "", "", "", "", "", "~", "", "y", "", "", "x", "", "",
	"", "", "", "", "", "O", "", "s", "l", "", "z", "^", "", "\", "", "e",
	"", "", "", "", "", "", "\", "", "", "l", "", "", "", "i", "", "c",
	"", "H", "", "", "", "", "Q", "_", "s", "", "", "", "", "", "S", "\",
	"", "", "z", "", "", "", "", "P", "Z", "", "E", "]", "", "", "", "",
	"", "", "@", "F", "", "M", "S", "", "", "", "P", "", "", "", "", "",
	"U", "", "", "", "", "", "", "d", "", "", "", "", "b", "", "D", "p",
	"i", "", "B", "Y", "", "X", "", "", "", "o", "", "X", "P", "~", "", "",
	"", "", "E", ".",  "+",  "C",  "D",  "F",  "", "X", "", "P", "", "h", "", "{", 
};

static const char *tbl_wordcode_mb2[] =
{
	/* 0x12 */
	/* 00 */	"",
	/* 01 */	"",
	/* 02 */	"",
	/* 03 */	"",
	/* 04 */	"",
	/* 05 */	"",
	/* 06 */	"",
	/* 07 */	"",
	/* 08 */	"傤B",
	/* 09 */	"́cc",
	/* 0a */	"KfBA",
	/* 0b */	"fBA",
	/* 0c */	"Ă",
	/* 0d */	"",
	/* 0e */	"ucc",
	/* 0f */	"Vlu",
	/* 10 */	"傤",
	/* 11 */	"łB",
	/* 12 */	"̎",
	/* 13 */	"E",
	/* 14 */	"ꂽ",
	/* 15 */	"",
	/* 16 */	"F̊L",
	/* 17 */	"_",
	/* 18 */	"",
	/* 19 */	"",
	/* 1a */	"؃_g",
	/* 1b */	"s",
	/* 1c */	"[l",
	/* 1d */	"l",
	/* 1e */	"Ȃ",
	/* 1f */	"cc?",
	/* 20 */	"A",
	/* 21 */	"\",
	/* 22 */	"ܗl",
	/* 23 */	"u",
	/* 24 */	"̌",
	/* 25 */	"KfBA",
	/* 26 */	"OB",
	/* 27 */	"uHX",
	/* 28 */	"",
	/* 29 */	"Eҗl",
	/* 2a */	"L[m",
	/* 2b */	"B",
	/* 2c */	"",
	/* 2d */	"Vu",
	/* 2e */	"Tl",
	/* 2f */	"̂ł",
	/* 30 */	"ł傤",
	/* 31 */	"Ă",
	/* 32 */	"",
	/* 33 */	"@",
	/* 34 */	"",
	/* 35 */	"lu",
	/* 36 */	"܂",
	/* 37 */	"܂",
	/* 38 */	"łA",
	/* 39 */	"Ă",
	/* 3a */	"",
	/* 3b */	"җl",
	/* 3c */	"mu",
	/* 3d */	"[ll",
	/* 3e */	"fBAl",
	/* 3f */	"uȁA",
	/* 40 */	"Ȃ",
	/* 41 */	"Ȃ",
	/* 42 */	"GlM[",
	/* 43 */	"ccB",
	/* 44 */	"00N",
	/* 45 */	"Ă",
	/* 46 */	"̌",
	/* 47 */	"OhI",
	/* 48 */	"肪Ƃ",
	/* 49 */	"s",
	/* 4a */	"Ă",
	/* 4b */	"",
	/* 4c */	"b!!",
	/* 4d */	"Q[g",
	/* 4e */	"ȂȂ",
	/* 4f */	"",
	/* 50 */	"u",
	/* 51 */	"m",
	/* 52 */	"V",
	/* 53 */	"{bg",
	/* 54 */	"Ă",
	/* 55 */	"ccB",
	/* 56 */	"X^[",
	/* 57 */	"X؃bLI",
	/* 58 */	"Ă܂",
	/* 59 */	"",
	/* 5a */	"",
	/* 5b */	"[b!",
	/* 5c */	"[l",
	/* 5d */	" l",
	/* 5e */	"A",
	/* 5f */	"ˁcc",
	/* 60 */	"Ȃ",
	/* 61 */	"Ă",
	/* 62 */	"s",
	/* 63 */	"",
	/* 64 */	"",
	/* 65 */	"\",
	/* 66 */	"̊L",
	/* 67 */	"łB",
	/* 68 */	"Ă܂",
	/* 69 */	"cc",
	/* 6a */	"̗",
	/* 6b */	"Ȃ",
	/* 6c */	"Ă",
	/* 6d */	"",
	/* 6e */	"",
	/* 6f */	"cc",
	/* 70 */	"",
	/* 71 */	"TCXl",
	/* 72 */	"̎",
	/* 73 */	"傤",
	/* 74 */	"\ҁu",
	/* 75 */	"cu",
	/* 76 */	"ˁccB",
	/* 77 */	"ȂȂ",
	/* 78 */	"Ă",
	/* 79 */	"킽",
	/* 7a */	"ꂽ",
	/* 7b */	"́cc",
	/* 7c */	"B",
	/* 7d */	"A",
	/* 7e */	"^V",
	/* 7f */	"",
	/* 80 */	"{",
	/* 81 */	"ccB",
	/* 82 */	"܂?",
	/* 83 */	"ȁccB",
	/* 84 */	"ȁA",
	/* 85 */	"",
	/* 86 */	"܂",
	/* 87 */	"AO",
	/* 88 */	" ?",
	/* 89 */	"uHXcc",
	/* 8a */	"u",
	/* 8b */	"u",
	/* 8c */	"킩Ȃ",
	/* 8d */	"񂾁B",
	/* 8e */	"",
	/* 8f */	"",
	/* 90 */	"A",
	/* 91 */	"_",
	/* 92 */	"OB",
	/* 93 */	"",
	/* 94 */	"܂傤",
	/* 95 */	"AU[",
	/* 96 */	"Ă",
	/* 97 */	"Ȃcc",
	/* 98 */	"AȂ",
	/* 99 */	"܂",
	/* 9a */	"",
	/* 9b */	"Ȃ",
	/* 9c */	"",
	/* 9d */	"Z",
	/* 9e */	"O",
	/* 9f */	"Ă܂",
	/* a0 */	"",
	/* a1 */	"cc",
	/* a2 */	"uȁA",
	/* a3 */	"̂؃_g",
	/* a4 */	"^ou",
	/* a5 */	"L[mu",
	/* a6 */	"ė",
	/* a7 */	"",
	/* a8 */	"B",
	/* a9 */	"݂",
	/* aa */	"Ȃ",
	/* ab */	"Ȃ",
	/* ac */	"Ȃ",
	/* ad */	"",
	/* ae */	"Vluɂ́A",
	/* af */	"P񕜂!",
	/* b0 */	"`",
	/* b1 */	"",
	/* b2 */	"Ⴂ",
	/* b3 */	"ĺA",
	/* b4 */	"m",
	/* b5 */	"HX",
	/* b6 */	"|Cg",
	/* b7 */	"肪Ƃ",
	/* b8 */	"̂łB",
	/* b9 */	"_g",
	/* ba */	"l",
	/* bb */	"",
	/* bc */	"bV",
	/* bd */	"KfBA",
	/* be */	"C_a",
	/* bf */	"Ă",
	/* c0 */	"",
	/* c1 */	"",
	/* c2 */	"",
	/* c3 */	"",
	/* c4 */	"",
	/* c5 */	"",
	/* c6 */	"",
	/* c7 */	"",
	/* c8 */	"",
	/* c9 */	"",
	/* ca */	"",
	/* cb */	"",
	/* cc */	"",
	/* cd */	"",
	/* ce */	"",
	/* cf */	"",
	/* d0 */	"",
	/* d1 */	"",
	/* d2 */	"",
	/* d3 */	"",
	/* d4 */	"",
	/* d5 */	"",
	/* d6 */	"",
	/* d7 */	"",
	/* d8 */	"",
	/* d9 */	"",
	/* da */	"",
	/* db */	"",
	/* dc */	"",
	/* dd */	"",
	/* de */	"",
	/* df */	"",
	/* e0 */	"",
	/* e1 */	"",
	/* e2 */	"",
	/* e3 */	"",
	/* e4 */	"",
	/* e5 */	"",
	/* e6 */	"",
	/* e7 */	"",
	/* e8 */	"",
	/* e9 */	"",
	/* ea */	"",
	/* eb */	"",
	/* ec */	"",
	/* ed */	"",
	/* ee */	"",
	/* ef */	"",
	/* f0 */	"",
	/* f1 */	"",
	/* f2 */	"",
	/* f3 */	"",
	/* f4 */	"",
	/* f5 */	"",
	/* f6 */	"",
	/* f7 */	"",
	/* f8 */	"",
	/* f9 */	"",
	/* fa */	"",
	/* fb */	"",
	/* fc */	"",
	/* fd */	"",
	/* fe */	"",
	/* ff */	"",
};

int dec_file(const char *ptr_readfilename, const char *ptr_writefilename, int flag_multibyte)
{
	int ch, ch2;
	FILE *fp_read  = NULL;
	FILE *fp_write = NULL;

	/* `FbN */
	assert(ptr_readfilename != NULL && *ptr_readfilename != '\0' && ptr_writefilename != NULL && *ptr_writefilename != '\0');
	if (ptr_readfilename == NULL || *ptr_readfilename == '\0' || ptr_writefilename == NULL || *ptr_writefilename == '\0')
		return 0;

	/* fR[ht@CJ */
	if ((fp_read = fopen(ptr_readfilename, "rb")) == NULL)
		return 0;

	/* fR[hʂo͂t@CJ */
	if ((fp_write = fopen(ptr_writefilename, "w")) == NULL)
	{
		fclose(fp_read);
		return 0;
	}

	/* fR[h */
	if (!flag_multibyte)
	{
		while ((ch = fgetc(fp_read)) != EOF)
		{
			if (ch == 0x00)	/* Kxɉs邽 */
				fputc('\n', fp_write);
			else
				fputs(tbl_charcode[ch], fp_write);
		}
	}
	else
	{
		while ((ch = fgetc(fp_read)) != EOF)
		{
			if (ch >= 0x01 && ch <= 0x02)	/* }`oCg */
			{
				if ((ch2 = fgetc(fp_read)) == EOF)
					break;

				fputs(tbl_charcode_mb2[((ch - 0x01) << 8) | ch2], fp_write);
			}
			else if (ch == 0x03)	/* ԑ҂R[h */
			{
				/* 1ǂݔ΂ */
				if (fgetc(fp_read) == EOF)
					break;
			}
			else if (ch == 0x12)	/* P */
			{
				if ((ch2 = fgetc(fp_read)) == EOF)
					break;

				fputs(tbl_wordcode_mb2[ch2], fp_write);
			}
			else if (ch == 0x00)	/* Kxɉs邽 */
				fputc('\n', fp_write);
			else
				fputs(tbl_charcode_mb1[ch], fp_write);
		}
	}

	fclose(fp_read);
	fclose(fp_write);
	fp_read  = NULL;
	fp_write = NULL;

	return 1;
}
